/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß                                     *
 *   z.o.gross@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIBQCROSS_CCROSSPACKAGE_H
#define LIBQCROSS_CCROSSPACKAGE_H

#include <QString>
#include <QList>

class QFile;

namespace libqnono {
	class CNonogram;
	
	typedef QList<CNonogram *> QMonoPictureList;
	
	class CCrossPackage {
	public:
		CCrossPackage();
		CCrossPackage(QString fileName);
		~CCrossPackage();
		
		virtual void setFileName(QString & value) { m_FileName = value; }
		QString fileName() const { return m_FileName; }
		
		void setName(QString value) { m_Name = value; }
		QString name() const { return m_Name; }
		
		bool open();
		void close();
		
		bool readHeader();
		bool readData();
		
		bool save();
		
		QMonoPictureList & pictures() { return m_PictureList; }
	private:
		QMonoPictureList m_PictureList;
		QString m_FileName;
		QString m_Name;
		QFile * m_File;
	};
}

#endif
